<template>
  <div>
    <!--内容-->
    <div class="layout-content-padding">
      <div class="layout-content-main">
        <Row>
          <!--查询-->
          <Col span="24">
            <Form id="search-form" :label-width="80" v-show="searchOpen" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item class="search-item" label="试样编号:">
                <Input @on-enter="_formSearch" v-model="formObj.sampleCode" name="sampleCode" placeholder="请输入样品名称" clearable/>
              </Form-item>
              <Form-item class="search-btn">
                <Button @click="_formSearch" type="primary">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <Col span="24">
            <btn-list :msg="btn" :open="searchOpen" @on-result-change="_btnClick" :showSearchBtn="true"
                     class="contHide">
            </btn-list>
          </Col>
          <!--样品数量-->
          <!-- 表格 -->
          <Col span="24">
            <PTVXETableHeight ref="pageTable" :table-height="tableHeight" :loading="true"
                              :get-page="getPage" @on-result-change="_tableResultChange" select-data>
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :min-width="item.width?item.width:200"
                :fixed="item.fixed?item.fixed:undefined" sortable>
                <template slot-scope="scope">
                  <span v-if="item.date">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd'):''}}</span>
                  <span v-else-if="item.status">{{scope.row[item.key].display}}</span>
                  <span v-else>{{scope.row[item.key]}}</span>
                </template>
              </vxe-table-column>
            </PTVXETableHeight>
          </Col>
        </Row>
      </div>
    </div>
    <Reason ref="reasonModal" @on-result-change="_reasonResult"></Reason>
    <SelectFlowRelBtn ref="flow"/>
  </div>
</template>
<script>
import Reason from '../../../../components/base/Reason'
// eslint-disable-next-line no-unused-vars
import http from '../../../../api/http'
import { soilSample } from '../../../../api'
import SelectFlowRelBtn from '../../../meter-entrust/entrust-review/SelectFlowRelBtn'
export default {
  components: {
    Reason,
    SelectFlowRelBtn
  },
  data() {
    return {
      currentComponent: '',
      searchOpen: false,
      formObj: {},
      selectData: [],
      selectIds: [],
      selectSampleIds: [],
      getPage: {},
      btn: [
        {
          type: 'primary',
          id: 'surplus-dispose-pass',
          name: '通过'
        },
        {
          type: '',
          id: 'surplus-dispose-back',
          name: '驳回'
        },
        {
          type: 'surplus-dispose-submit-flow',
          id: 'surplus-dispose-submit-flow',
          name: '提交审批'
        }
        // { type: '', id: '', name: '填写存放信息' },
        // { type: '', id: '', name: '申请处理' },
        // { type: '', id: '', name: '导出' },
      ],
      iconMsg: [
        { type: 'md-create', id: 'surplus-dispose-edit', name: '编辑' } // food-sample-prepare-edit
      ],
      iconMsgSave: [
        { type: 'ios-checkmark', id: 'surplus-dispose-save', name: '保存' }
      ],
      pageColumns: [
        { title: '试样编号', key: 'sampleCode', width: 150 },
        { title: '状态', key: 'status', status: true, width: 100 },
        { title: '包装类型', key: 'samplePack', width: 100 },
        { title: '保存容器', key: 'keepContainer', width: 100 },
        { title: '制备数量', key: 'quantity', width: 100 },
        { title: '单位', key: 'unit', width: 70 },
        { title: '制备人', key: 'preparer', width: 130 },
        { title: '制备时间', key: 'prepareDate', date: true, width: 130 }
        /*  {title: '处置方式', key: 'handleMethod', width: 120,}, */
      ],
      currentIndex: -1,
      editIndex: -1,
      endDateBegin: '',
      endDateEnd: '',
      // 只看预警和超期样品
      isEligible: ''
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('', 255)
      } else {
        return this.$tableHeight('', 220)
      }
    }
  },
  mounted() {},
  methods: {
    // 重新请求page以及备样数量
    _relPage() {
      this._page()
      // this._getBackUpCount()
    },
    // 选择时间
    _endDateChange(data) {
      this.getPage.records[this.currentIndex].endDate = data
    },
    // 查询-接收日期
    _dateChange(data) {
      this.endDateBegin = data[0]
      this.endDateEnd = data[1]
    },
    _iconClick(res, data, componentName, index) {
      this.currentIndex = index
      switch (res) {
        case '编辑':
          this.editIndex = index
          break
        case '保存':
          console.log('保存')
          // if (data.endDate !== '') {
          //   // 非空情况下格式化赋值，如果不判断会格式化为当天的日期
          //   this._endDateChange(this.$dateformat(data.endDate, 'yyyy-mm-dd'))
          // }
          // this._save()
          this.editIndex = -1
          break
      }
    },
    // 操作的序号
    _handleIndex(data) {
      this.currentIndex = data.rowIndex
    },
    _btnClick(msg) {
      switch (msg) {
        case '通过':
          this._dispose()
          break
        case '提交审批':
          this._submit('surplus-dispose-submit-flow')
          break
        case '驳回':
          this._disposeBack()
          break
        case '制备':
          this._preMethod()
          break
        case '无需制备':
          this._noPreMethod()
          break
        case '扫码制备':
          this._scanPreMethod()
          break
        case '填写存放信息':
          this._batchEdit()
          break
        case '申请处理':
          this._handle()
          break
        case '导出':
          if (this.getPage.records.length === 0) {
            this.$Message.warning('暂无数据，不可导出')
          } else {
            this._export()
          }
          break
        case '导出备样记录':
          this._exportReceiveRecord()
          break
        case 'search':
          this.searchOpen = !this.searchOpen
          break
      }
    },
    _submit(key) {
      this.$refs.flow._open(key)
    },
    // 通过
    _dispose() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选择一条数据')
      } else {
        this.$Modal.confirm({
          title: '提示',
          content: '确定通过这 ' + this.selectIds.length + ' 条数据？',
          onOk: () => {
            this._disposeOk(this.selectIds.join(','))
          }
        })
      }
    },
    _disposeBack() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选择一条委托！')
      } else {
        this.$refs.reasonModal._open('退回原因')
      }
    },
    _reasonResult(data) {
      if (undefined !== data && data !== '') {
        this._reportCheckBack(data)
      }
    },
    _reportCheckBack: async function(data) {
      const result = await soilSample.surplueDisposalFail({
        ids: this.selectIds.join(','),
        reason: data
      })

      if (result) {
        this.$Message.success('退回成功！')
        console.log('退回成功')
        await this._page()
      }
    },
    _disposeOk: async function(ids) {
      const result = await soilSample.surplusDisposalOk({ ids: ids })
      if (result) {
        this._resultChange('提交成功')
      }
    },
    _resultChange(msg) {
      this.$Message.success(msg)
      this._page()
    },
    // 制备
    _preMethod() {
      if (this.selectSampleIds.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$refs.preModal._open(this.selectSampleIds)
      }
    },
    // 无需制备
    _noPreMethod() {
      if (this.selectSampleIds.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$refs.noPreModal._open(this.selectSampleIds)
      }
    },
    _scanPreMethod() {
      this.$refs.scanPreModal._open()
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'selectData':
          this.selectData = data
          this.selectIds = []
          this.selectSampleIds = []
          for (let i = 0; i < data.length; i++) {
            this.selectIds.push(data[i].id)
            this.selectSampleIds.push(data[i].sampleId)
          }
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
      // this._getBackUpCount()
    },
    _page: async function() {
      this.editIndex = -1
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await soilSample.pageSurplusHandleCheck(
        this.$serializeForm(this.formObj)
      )
      if (result) {
        this.$refs.pageTable._hideLoading()
        this.getPage = result
      }
    },
    _batchEdit() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择一条或多条数据！')
      } else {
        this.$refs.editModal._open(this.selectData)
      }
    },
    _handle() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择一条或多条数据！')
      } else {
        this.$refs.applyModal._open(this.selectData)
      }
    },
    // 参数
    _searchParams() {
      const data = this.$serialize('search-form')
      return this.$extend(data, { page: 1, rows: 5000 })
    }
    /** *********************************导出样品台账-end*********************************************/
  }
}
</script>
<style scoped>
/******副样、备样卡片********/
.reimbursement-item {
  flex: 1;
  border-radius: 5px;
  border: 1px solid #e8e8e8;
  padding-bottom: 10px;
}

.reimbursement-item + .reimbursement-item {
  margin-left: 20px;
}

.reimbursement-item p {
  text-align: center;
  margin: 0;
}

.reimbursement-item > p:first-child {
  font-size: 22px;
  line-height: 40px;
}
</style>
